<?

class osC_Payment_cashqiwi extends osC_Payment
{
	var $_title,
        $_code = 'cashqiwi',
        $_status = false,
        $_sort_order,
		$cheched,
		$form,
        $_order_id;
	
	function osC_Payment_cashqiwi()
	{
	  global $code, $title, $description, $enabled;

		$this->_title = 'QIWI (Cash24)';
		$this->_description = '<a href="http://www.cash24.ru" target="_blank" style="text-decoration: underline; font-weight: bold;">Сайт платёжной системы Cash24</a>';
		$this->_method_title = 'QIWI (Cash24)';
		$this->_status = (defined('MODULE_PAYMENT_CASHQIWI_STATUS') && (MODULE_PAYMENT_CASHQIWI_STATUS == '1') ? true : false);
		$this->_sort_order = (defined('MODULE_PAYMENT_CASHQIWI_SORT_ORDER') ? MODULE_PAYMENT_CASHQIWI_SORT_ORDER : null);

      $this->form_action_url = 'cash24process.php';
    }
	
	
	
	//выбор метода оплаты
	function selection()
	{
		global $checked, $form;
		
		

		return array('id' => $this->_code,'module' => $this->_method_title, 'fields' => array(array('title' => '', 'field' => $form)));
    }
	
	function confirmation()
	{
      $this->_order_id = osC_Order::insert();
    }
	
	function process_button()
	{
		 global $osC_Customer, $osC_Currencies, $osC_ShoppingCart;
		
		$order_id = $this->_order_id;
		$total_price = $osC_Currencies->formatRaw($osC_ShoppingCart->getTotal(), 'RUB');
		 $datexp=MODULE_PAYMENT_CASHQIWI_EXP;
				 $time = time() + $datexp * 24 * 60 * 60;
  $exptime=gmdate('Y-m-d', $time) . 'T' . gmdate('H:i:s', $time);
 

$arParams = array();
$arParams['amount']=$total_price;
$arParams['currency']='RUB';
$arParams['email']= $osC_Customer->getEmailAddress();
$arParams['description']='Order '.$order_id;
$arParams['order']=$order_id;
$arParams['success']=htmlspecialchars(MODULE_PAYMENT_CASHQIWI_MERCH_REDIRECT_PAGE);
$arParams['cancel']=htmlspecialchars(MODULE_PAYMENT_CASHQIWI_MERCH_REDIRECT_PAGE2);
$arParams['callback']=osc_href_link(FILENAME_CHECKOUT, 'callback&module=' . $this->_code, 'SSL', null, null, true);
$arParams['method']='qiwi';
$arParams['phone']=$osC_ShoppingCart->getBillingAddress('telephone_number');
$arParams['wallet']='';
$arParams['expires']=$exptime;


$headers = array(
    "Content-type: text/xml"
    
);
$k= $this->createInvoice($arParams,MODULE_PAYMENT_CASHQIWI_LOGIN,MODULE_PAYMENT_CASHQIWI_PASSWORD2);

switch (MODULE_PAYMENT_CASHQIWI_TESTMODE) {
				case 'Включен':
					$respurl="http://api.staging.cash24.ru/1.0/";
					break;
				case 'Выключен':
					$respurl="https://api.cash24.ru/1.0/";
					break;
			}
			
			 $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $respurl);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER,true);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $k);
 curl_setopt($curl, CURLOPT_HTTPHEADER, $headers );
  
 curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
    $out = curl_exec($curl);
	

$url = simplexml_load_string($out);

$turl= $url;
 
  $url = $url->response->url; //формируем строку url

  if(!empty($turl->envelope->error)){
  
  
die("<font color=red><b>".$turl->envelope->text."<b></font>");
  
  }
  unset($_SESSION['osC_ShoppingCart_data']);
	unset($_SESSION['cartID']);
	unset($_SESSION['prepOrderID']);
		$selected_pay_system = intval($_POST['selected_pay_system_id']);
		$process_button_string = osc_draw_hidden_field('order_id', $order_id) . osc_draw_hidden_field('pay_system', $selected_pay_system) . osc_draw_hidden_field('action', $url);
		return $process_button_string;
    }
	
	function process()
	{
		return false;
    }

	function remove()
	{
		osc_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function callback()
	{
		global $osC_Database;				$request=$_POST;$order_id=$request['order'];if($request['status']=='20'){	    osC_Order::process($order_id, MODULE_PAYMENT_CASHQIWI_ORDER_STATUS20);}if($request['status']=='40'){					    osC_Order::process($order_id, MODULE_PAYMENT_CASHQIWI_ORDER_STATUS40);        		}if($request['status']=='30'){  osC_Order::process($order_id, MODULE_PAYMENT_CASHQIWI_ORDER_STATUS30);  }if($request['status']=='50'){  osC_Order::process($order_id, MODULE_PAYMENT_CASHQIWI_ORDER_STATUS50);  }
	}
	private function createInvoice($arParams,$auth,$key)
 {
  
  $request = '';
  $toSign = 'create-invoice';
  foreach ($arParams as $c => $val)
  {
   $request .= "<$c>" . $val . "</$c>\r\n";
   if ($c != 'expires' AND $c != 'phone')
    $toSign .= '-' . $val;
  }

  $sign = md5(htmlspecialchars_decode($toSign) . '-' . $key);

  $xml = '
   <?xml version="1.0" encoding="utf-8"?>
   <cash24 xmlns="http://api.cash24.ru/1.0/">
     <request xmlns="http://api.cash24.ru/1.0/create-invoice/">
    ' . $request . '
     </request>
     <envelope>
    <auth>' . $auth . '</auth>
    <sign>' . $sign . '</sign>
     </envelope>
   </cash24>
  ';

  return trim($xml);
 }
}
?>