<?php



class osC_Payment_cashbeeline extends osC_Payment_Admin

{

    var $_title;

    var $_code = 'cashbeeline';

    var $_author_name = 'www.cash24.ru';

    var $_author_www = 'http://www.cash24.ru';

    var $_status = false;



    function osC_Payment_cashbeeline()

	{

		global $osC_Database, $osC_Language;



		$this->_title = 'Со счета мобильного Билайн (Cash24)';

		$this->_description = '<a href="http://www.cash24.ru" target="_blank" style="text-decoration: underline; font-weight: bold;">Сайт платёжной системы Cash24</a>';

		$this->_method_title = 'Со счета мобильного Билайн (Cash24)';

		$this->_status = (defined('MODULE_PAYMENT_CASHBEELINE_STATUS') && (MODULE_PAYMENT_CASHBEELINE_STATUS == '1') ? true : false);

		$this->_sort_order = (defined('MODULE_PAYMENT_CASHBEELINE_SORT_ORDER') ? MODULE_PAYMENT_CASHBEELINE_SORT_ORDER : null);

	}





    function isInstalled()

	{

      return (bool)defined('MODULE_PAYMENT_CASHBEELINE_STATUS');

    }



    function install()

	{

      global $osC_Database;



      parent::install();



		$osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Платформа Cash24', 'MODULE_PAYMENT_CASHBEELINE_STATUS', '1', 'Включить ?', '6', '0', 'osc_cfg_use_get_boolean_value', 'osc_cfg_set_boolean_value(array(1, -1))', now())");

		

		$osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant Id', 'MODULE_PAYMENT_CASHBEELINE_LOGIN', '', '', '6', '0', now())");	



		$osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Secret Key', 'MODULE_PAYMENT_CASHBEELINE_PASSWORD1', '', '', '6', '0', now())");	



		$osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Command Key', 'MODULE_PAYMENT_CASHBEELINE_PASSWORD2', '', '', '6', '0', now())");	

		

		$osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Оплачен', 'MODULE_PAYMENT_CASHBEELINE_ORDER_STATUS20', '0', '', '6', '0', 'osc_cfg_set_order_statuses_pull_down_menu(', 'osc_get_order_status_name', now())");

		

		$osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Отменен', 'MODULE_PAYMENT_CASHBEELINE_ORDER_STATUS30', '0', '', '6', '0', 'osc_cfg_set_order_statuses_pull_down_menu(', 'osc_get_order_status_name', now())");

		

		$osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Доставлен', 'MODULE_PAYMENT_CASHBEELINE_ORDER_STATUS40', '0', '', '6', '0', 'osc_cfg_set_order_statuses_pull_down_menu(', 'osc_get_order_status_name', now())");

		

		$osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Возвращен', 'MODULE_PAYMENT_CASHBEELINE_ORDER_STATUS50', '0', '', '6', '0', 'osc_cfg_set_order_statuses_pull_down_menu(', 'osc_get_order_status_name', now())");

		

		$osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Страница оплаты', 'MODULE_PAYMENT_CASHBEELINE_MERCH_REDIRECT_PAGE', '', '', '6', '0', now())");

		

		$osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Неудачная оплаты', 'MODULE_PAYMENT_CASHBEELINE_MERCH_REDIRECT_PAGE2', '', '', '6', '0', now())");



		$osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Порядок сортировки', 'MODULE_PAYMENT_CASHBEELINE_SORT_ORDER', '0', 'Порядок сортировки модуля', '6', '0', now())");

		$osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Срок действия счета (суток)', 'MODULE_PAYMENT_CASHBEELINE_EXP', '1', '', '6', '0', now())");

		

		$osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Тестовый режим', 'MODULE_PAYMENT_CASHBEELINE_TESTMODE', 'Включен', '', '6', '0', 'osc_cfg_use_get_boolean_value', 'osc_cfg_set_boolean_value(array(\'Включен\', \'Выключен\'))', now())");

    

	

	}



    function getKeys()

	{

      if (!isset($this->_keys)) {

        $this->_keys = array('MODULE_PAYMENT_CASHBEELINE_STATUS',

                             'MODULE_PAYMENT_CASHBEELINE_LOGIN',

                             'MODULE_PAYMENT_CASHBEELINE_PASSWORD1',

                             'MODULE_PAYMENT_CASHBEELINE_PASSWORD2',

							 'MODULE_PAYMENT_CASHBEELINE_ORDER_STATUS20',

                             'MODULE_PAYMENT_CASHBEELINE_ORDER_STATUS30',

							 'MODULE_PAYMENT_CASHBEELINE_ORDER_STATUS40',

							 'MODULE_PAYMENT_CASHBEELINE_ORDER_STATUS50',

							 'MODULE_PAYMENT_CASHBEELINE_MERCH_REDIRECT_PAGE',

							 'MODULE_PAYMENT_CASHBEELINE_MERCH_REDIRECT_PAGE2',

							 'MODULE_PAYMENT_CASHBEELINE_SORT_ORDER',

							  'MODULE_PAYMENT_CASHBEELINE_EXP',

							 'MODULE_PAYMENT_CASHBEELINE_TESTMODE');

      }



      return $this->_keys;

    }

}

?>

